"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _TextArea = _interopRequireDefault(require("antd/lib/input/TextArea"));

require("antd/lib/input/style/index.css");

require("./LimitTextArea.less");

/***
 * 显示最大输入字符数
 * maxLength：200（默认）
 */
var LimitTextArea =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(LimitTextArea, _PureComponent);

  function LimitTextArea(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, LimitTextArea);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(LimitTextArea).call(this, props));

    _this.handleChange = function (e) {
      var val = e.target.value;

      _this.setState({
        val: val
      });
    };

    _this.state = {
      val: '',
      maxLength: 200,
      isvalid: true // 是否显示最大字符数

    }; // 若需要覆盖onChange时，value必填

    if (props.onChange && !props.hasOwnProperty('value')) {
      _this.state.isvalid = false;
      console.warn('LimitTextArea：绑定onChange时，value属性必填，否则显示最大输入字符数将失效!');
    }

    return _this;
  } // 若外部定义了onChange事件，handleChange将会被覆盖


  (0, _createClass2["default"])(LimitTextArea, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          defaultMax = _this$state.maxLength,
          isvalid = _this$state.isvalid;
      var _this$props = this.props,
          sep = _this$props.sep,
          maxLength = _this$props.maxLength,
          value = _this$props.value,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["sep", "maxLength", "value"]);
      var max = maxLength > 0 ? maxLength : defaultMax;
      /** form组件中，value有值 */

      var arr = (value || this.state.val).split(sep);
      var len = arr.length > max ? max : arr.length;
      /**截取最大字符串 */

      var val = arr.slice(0, len).join(sep);
      var n = val ? len : 0;
      var suffix = "".concat(n, "/").concat(max);
      return isvalid ? _react["default"].createElement("div", {
        className: 'block'
      }, _react["default"].createElement(_TextArea["default"], (0, _extends2["default"])({
        onChange: function onChange(e) {
          return _this2.handleChange(e);
        },
        value: val
      }, restProps)), _react["default"].createElement("span", {
        className: 'counter'
      }, suffix)) : _react["default"].createElement(_TextArea["default"], this.props);
    }
  }]);
  return LimitTextArea;
}(_react.PureComponent);

LimitTextArea.defaultProps = {
  /** 分割符
   * 可以是个字符串，如：'\n'
   * 也可以是个正则表达式，如：/\n\r/
   */
  sep: ''
};
var _default = LimitTextArea;
exports["default"] = _default;